// SampleVC6Dlg.cpp : implementation file
//

#include "stdafx.h"
#include "SampleVC6.h"
#include "SampleVC6Dlg.h"

#include "LEPCLIB.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSampleVC6Dlg dialog

CSampleVC6Dlg::CSampleVC6Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSampleVC6Dlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSampleVC6Dlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CSampleVC6Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSampleVC6Dlg)
	DDX_Control(pDX, IDC_RUN, m_cntRUN);
	DDX_Control(pDX, IDC_CONNECT, m_cntCONNECT);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CSampleVC6Dlg, CDialog)
	//{{AFX_MSG_MAP(CSampleVC6Dlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_CONNECT, OnConnect)
	ON_BN_CLICKED(IDC_RUN, OnRun)
	ON_BN_CLICKED(IDC_KEY0, OnKey0)
	ON_BN_CLICKED(IDC_KEY1, OnKey1)
	ON_BN_CLICKED(IDC_KEY2, OnKey2)
	ON_BN_CLICKED(IDC_GETMONITOR, OnGetmonitor)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSampleVC6Dlg message handlers

BOOL CSampleVC6Dlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CSampleVC6Dlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

HCURSOR CSampleVC6Dlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CSampleVC6Dlg::OnConnect() 
{
	int err;
	if( m_cntCONNECT.GetCheck() ){
		err = LEConnect("COM1");
		if( err == LE_FAIL ){
			MessageBox(_T("connect error"));
			m_cntCONNECT.SetCheck(FALSE);
		}
	} else {
		LEDisconnect();
	}
}

void CSampleVC6Dlg::OnRun() 
{
	int err;
	if( m_cntRUN.GetCheck() ){
		err = LEStartMeasure();
		if( err == LE_FAIL ){
			MessageBox(_T("run error"));
			m_cntRUN.SetCheck(FALSE);
		}
	} else {
		LEStopMeasure();
	}
}

void CSampleVC6Dlg::OnKey0() 
{
	LEEmulationKey(LE_REMOTE_KEY_0);
}

void CSampleVC6Dlg::OnKey1() 
{
	LEEmulationKey(LE_REMOTE_KEY_1);
}

void CSampleVC6Dlg::OnKey2() 
{
	LEEmulationKey(LE_REMOTE_KEY_2);
}

void CSampleVC6Dlg::OnGetmonitor() 
{
	DWORD size = 4096;

	int err;
	LE_MONDATA *mondata = new LE_MONDATA[size];
	err = LEGetMonitorData(mondata, &size);
	if( err == LE_FAIL ){
		MessageBox(_T("get error"));
		delete[] mondata;
		return;
	}

	CFileDialog dlg (FALSE, _T(".csv"), _T("MONDATA.CSV"), NULL, _T("CSV(*.csv)|*.csv|All(*.*)|*.*||"));
	if( dlg.DoModal() == IDOK ){
		CString filename;
		CFile file;
		filename = dlg.GetPathName();
		if( file.Open(filename, CFile::modeCreate | CFile::modeWrite) == 0 ){
			MessageBox(_T("open error"));
			delete[] mondata;
			return;
		}
		for( DWORD i = 0; i < size; i ++ ){
			char str[10],strSD[10],strRD[10];
			sprintf(strSD, "%02X", mondata[i].SD);
			sprintf(strRD, "%02X", mondata[i].RD);
			if( !(mondata[i].statusSD & LE_MONSTATUS_DATA_VISIBLE) ){
				strcpy( strSD, _T("--") );
			}
			if( !(mondata[i].statusRD & LE_MONSTATUS_DATA_VISIBLE) ){
				strcpy( strRD, _T("--") );
			}

			sprintf(str,"%s,%s\r\n", strSD, strRD);
			file.Write(str, strlen(str));
		}
		file.Close();
		MessageBox(_T("success"));
	}

	delete[] mondata;
}
